diff --git a/testsuite/integration-arquillian/test-apps/spring-boot-adapter/.gitignore b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/.gitignore
new file mode 100644
index 0000000000..2af7cefb0a
--- /dev/null
+++ b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/.gitignore
@@ -0,0 +1,24 @@
+target/
+!.mvn/wrapper/maven-wrapper.jar
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+nbproject/private/
+build/
+nbbuild/
+dist/
+nbdist/
+.nb-gradle/
\ No newline at end of file
diff --git a/testsuite/integration-arquillian/test-apps/spring-boot-adapter/mvnw b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/mvnw
new file mode 100755
index 0000000000..5bf251c077
--- /dev/null
+++ b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/mvnw
@@ -0,0 +1,225 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven2 Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Migwn, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+ # TODO classpath?
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`which java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+echo $MAVEN_PROJECTBASEDIR
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/testsuite/integration-arquillian/test-apps/spring-boot-adapter/mvnw.cmd b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/mvnw.cmd
new file mode 100644
index 0000000000..019bd74d76
--- /dev/null
+++ b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/mvnw.cmd
@@ -0,0 +1,143 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM http://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven2 Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a key stroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM enable echoing my setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_pre.bat" call "%HOME%\mavenrc_pre.bat"
+if exist "%HOME%\mavenrc_pre.cmd" call "%HOME%\mavenrc_pre.cmd"
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+%MAVEN_JAVA_EXE% %JVM_CONFIG_MAVEN_PROPS% %MAVEN_OPTS% %MAVEN_DEBUG_OPTS% -classpath %WRAPPER_JAR% "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_post.bat" call "%HOME%\mavenrc_post.bat"
+if exist "%HOME%\mavenrc_post.cmd" call "%HOME%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%" == "on" pause
+
+if "%MAVEN_TERMINATE_CMD%" == "on" exit %ERROR_CODE%
+
+exit /B %ERROR_CODE%
diff --git a/testsuite/integration-arquillian/test-apps/spring-boot-adapter/pom.xml b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/pom.xml
new file mode 100644
index 0000000000..d214a48f79
--- /dev/null
+++ b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/pom.xml
@@ -0,0 +1,124 @@
+
+
+ 4.0.0
+
+ org.keycloak
+ spring-boot-adapter
+ 0.0.1-SNAPSHOT
+ jar
+
+ spring-boot-adapter
+ Spring boot adapter test application
+
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 1.5.3.RELEASE
+
+
+
+
+ UTF-8
+ UTF-8
+ 1.8
+
+ -
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+
+ org.keycloak
+ keycloak-spring-boot-adapter
+ ${keycloak.version}
+
+
+
+
+
+
+ spring-boot-adapter-tomcat
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+ org.keycloak
+ keycloak-tomcat8-adapter
+ ${keycloak.version}
+
+
+
+
+
+ spring-boot-adapter-jetty
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+ org.springframework.boot
+ spring-boot-starter-tomcat
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter-jetty
+
+
+
+ org.keycloak
+ keycloak-jetty94-adapter
+ ${keycloak.version}
+
+
+
+
+
+ spring-boot-adapter-undertow
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+ org.springframework.boot
+ spring-boot-starter-tomcat
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter-undertow
+
+
+
+ org.keycloak
+ keycloak-undertow-adapter
+ ${keycloak.version}
+
+
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+
+
+
+
diff --git a/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/java/org/keycloak/SpringBootAdapterApplication.java b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/java/org/keycloak/SpringBootAdapterApplication.java
new file mode 100644
index 0000000000..3833299034
--- /dev/null
+++ b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/java/org/keycloak/SpringBootAdapterApplication.java
@@ -0,0 +1,12 @@
+package org.keycloak;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+
+@SpringBootApplication
+public class SpringBootAdapterApplication {
+
+ public static void main(String[] args) {
+ SpringApplication.run(SpringBootAdapterApplication.class, args);
+ }
+}
diff --git a/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/resources/application.properties b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/resources/application.properties
new file mode 100644
index 0000000000..d8749d3a53
--- /dev/null
+++ b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/resources/application.properties
@@ -0,0 +1,11 @@
+server.port=8280
+
+keycloak.realm=test
+keycloak.auth-server-url=http://localhost:8180/auth
+keycloak.ssl-required=external
+keycloak.resource=spring-boot-app
+keycloak.credentials.secret=e3789ac5-bde6-4957-a7b0-612823dac101
+
+keycloak.security-constraints[0].authRoles[0]=admin
+keycloak.security-constraints[0].securityCollections[0].name=Admin zone
+keycloak.security-constraints[0].securityCollections[0].patterns[0]=/admin/*
\ No newline at end of file
diff --git a/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/resources/static/admin/index.html b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/resources/static/admin/index.html
new file mode 100644
index 0000000000..acb47afb71
--- /dev/null
+++ b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/resources/static/admin/index.html
@@ -0,0 +1,12 @@
+
+
+
+
+ springboot admin page
+
+
+
+ You are now admin
+
+
+
\ No newline at end of file
diff --git a/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/resources/static/index.html b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/resources/static/index.html
new file mode 100644
index 0000000000..5ca7303992
--- /dev/null
+++ b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/main/resources/static/index.html
@@ -0,0 +1,12 @@
+
+
+
+
+ springboot test page
+
+
+
+
+
+
+
\ No newline at end of file
diff --git a/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/test/java/org/keycloak/SpringBootAdapterApplicationTests.java b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/test/java/org/keycloak/SpringBootAdapterApplicationTests.java
new file mode 100644
index 0000000000..8df20da764
--- /dev/null
+++ b/testsuite/integration-arquillian/test-apps/spring-boot-adapter/src/test/java/org/keycloak/SpringBootAdapterApplicationTests.java
@@ -0,0 +1,16 @@
+package org.keycloak;
+
+import org.junit.Test;
+import org.junit.runner.RunWith;
+import org.springframework.boot.test.context.SpringBootTest;
+import org.springframework.test.context.junit4.SpringRunner;
+
+@RunWith(SpringRunner.class)
+@SpringBootTest
+public class SpringBootAdapterApplicationTests {
+
+ @Test
+ public void contextLoads() {
+ }
+
+}
diff --git a/testsuite/integration-arquillian/tests/other/pom.xml b/testsuite/integration-arquillian/tests/other/pom.xml
index 03f126c384..f406421e96 100644
--- a/testsuite/integration-arquillian/tests/other/pom.xml
+++ b/testsuite/integration-arquillian/tests/other/pom.xml
@@ -39,6 +39,7 @@
adapters
sssd
+ springboot-tests
diff --git a/testsuite/integration-arquillian/tests/other/springboot-tests/pom.xml b/testsuite/integration-arquillian/tests/other/springboot-tests/pom.xml
new file mode 100644
index 0000000000..90a997f344
--- /dev/null
+++ b/testsuite/integration-arquillian/tests/other/springboot-tests/pom.xml
@@ -0,0 +1,89 @@
+
+
+
+ integration-arquillian-tests-other
+ org.keycloak.testsuite
+ 3.3.0.CR1-SNAPSHOT
+
+ 4.0.0
+
+ integration-arquillian-tests-springboot
+
+
+ **/springboot/**/*Test.java
+
+ tomcat
+
+
+
+
+ org.keycloak
+ keycloak-test-helper
+ ${project.version}
+
+
+
+
+
+
+
+ maven-surefire-plugin
+
+
+ ${exclude.springboot}
+
+
+
+
+
+
+
+
+ test-springboot
+
+ -
+
+
+
+
+
+ com.bazaarvoice.maven.plugins
+ process-exec-maven-plugin
+ 0.7
+
+
+ spring-boot-application-process
+ generate-test-resources
+
+ start
+
+
+ springboot
+ ../../../../test-apps/spring-boot-adapter
+
+ mvn
+ spring-boot:run
+ -Dkeycloak.version=${project.version}
+ -Pspring-boot-adapter-${adapter.container}
+
+
+
+
+
+ kill-processes
+ post-integration-test
+
+ stop-all
+
+
+
+
+
+
+
+
+
+
+
\ No newline at end of file
diff --git a/testsuite/integration-arquillian/tests/other/springboot-tests/src/main/java/org/keycloak/testsuite/springboot/SpringAdminPage.java b/testsuite/integration-arquillian/tests/other/springboot-tests/src/main/java/org/keycloak/testsuite/springboot/SpringAdminPage.java
new file mode 100644
index 0000000000..8ce5e75688
--- /dev/null
+++ b/testsuite/integration-arquillian/tests/other/springboot-tests/src/main/java/org/keycloak/testsuite/springboot/SpringAdminPage.java
@@ -0,0 +1,22 @@
+package org.keycloak.testsuite.springboot;
+
+import org.keycloak.testsuite.pages.AbstractPage;
+import org.openqa.selenium.WebElement;
+import org.openqa.selenium.support.FindBy;
+
+public class SpringAdminPage extends AbstractPage {
+
+ @FindBy(className = "test")
+ private WebElement testDiv;
+
+
+ @Override
+ public boolean isCurrent() {
+ return driver.getTitle().equalsIgnoreCase("springboot admin page");
+ }
+
+ @Override
+ public void open() throws Exception {
+
+ }
+}
diff --git a/testsuite/integration-arquillian/tests/other/springboot-tests/src/main/java/org/keycloak/testsuite/springboot/SpringApplicationPage.java b/testsuite/integration-arquillian/tests/other/springboot-tests/src/main/java/org/keycloak/testsuite/springboot/SpringApplicationPage.java
new file mode 100644
index 0000000000..9442cd3769
--- /dev/null
+++ b/testsuite/integration-arquillian/tests/other/springboot-tests/src/main/java/org/keycloak/testsuite/springboot/SpringApplicationPage.java
@@ -0,0 +1,40 @@
+package org.keycloak.testsuite.springboot;
+
+import org.keycloak.testsuite.pages.AbstractPage;
+import org.openqa.selenium.WebElement;
+import org.openqa.selenium.support.FindBy;
+
+public class SpringApplicationPage extends AbstractPage {
+
+ @FindBy(className = "test")
+ private WebElement testDiv;
+
+ @FindBy(className = "adminlink")
+ private WebElement adminLink;
+
+ private String title;
+
+ public SpringApplicationPage() {
+ super();
+
+ title = "springboot test page";
+ }
+
+ public String getTitle() {
+ return title;
+ }
+
+ @Override
+ public boolean isCurrent() {
+ return driver.getTitle().equalsIgnoreCase(title);
+ }
+
+ @Override
+ public void open() throws Exception {
+
+ }
+
+ public void goAdmin() {
+ adminLink.click();
+ }
+}
diff --git a/testsuite/integration-arquillian/tests/other/springboot-tests/src/test/java/org/keycloak/testsuite/springboot/SpringBootTest.java b/testsuite/integration-arquillian/tests/other/springboot-tests/src/test/java/org/keycloak/testsuite/springboot/SpringBootTest.java
new file mode 100644
index 0000000000..d8f574f2f2
--- /dev/null
+++ b/testsuite/integration-arquillian/tests/other/springboot-tests/src/test/java/org/keycloak/testsuite/springboot/SpringBootTest.java
@@ -0,0 +1,229 @@
+package org.keycloak.testsuite.springboot;
+
+import org.jboss.arquillian.graphene.page.Page;
+import org.jboss.logging.Logger;
+import org.junit.After;
+import org.junit.Assert;
+import org.junit.Before;
+import org.junit.Test;
+import org.keycloak.admin.client.resource.RealmResource;
+import org.keycloak.admin.client.resource.RoleResource;
+import org.keycloak.representations.idm.ClientRepresentation;
+import org.keycloak.representations.idm.RealmRepresentation;
+import org.keycloak.representations.idm.RoleRepresentation;
+import org.keycloak.representations.idm.UserRepresentation;
+import org.keycloak.test.TestsHelper;
+import org.keycloak.testsuite.AbstractKeycloakTest;
+import org.keycloak.testsuite.admin.ApiUtil;
+import org.keycloak.testsuite.arquillian.SuiteContext;
+import org.keycloak.testsuite.pages.LoginPage;
+import org.openqa.selenium.WebDriver;
+import org.openqa.selenium.support.ui.ExpectedCondition;
+import org.openqa.selenium.support.ui.WebDriverWait;
+
+import java.io.UnsupportedEncodingException;
+import java.net.URLEncoder;
+import java.util.Collections;
+import java.util.List;
+
+import static org.keycloak.testsuite.admin.ApiUtil.*;
+
+public class SpringBootTest extends AbstractKeycloakTest {
+
+ private static final Logger log = Logger.getLogger(SpringBootTest.class);
+ private static final String REALM_NAME = "test";
+
+ private static final String CLIENT_ID = "spring-boot-app";
+ private static final String SECRET = "e3789ac5-bde6-4957-a7b0-612823dac101";
+
+ private static final String APPLICATION_URL = "http://localhost:8280";
+ private static final String BASE_URL = APPLICATION_URL + "/admin";
+
+ private static final String USER_LOGIN = "testuser";
+ private static final String USER_EMAIL = "user@email.test";
+ private static final String USER_PASSWORD = "user-password";
+
+ private static final String USER_LOGIN_2 = "testuser2";
+ private static final String USER_EMAIL_2 = "user2@email.test";
+ private static final String USER_PASSWORD_2 = "user2-password";
+
+ private static final String CORRECT_ROLE = "admin";
+ private static final String INCORRECT_ROLE = "wrong-admin";
+
+ @Page
+ private LoginPage loginPage;
+
+ @Page
+ private SpringApplicationPage applicationPage;
+
+ @Page
+ private SpringAdminPage adminPage;
+
+ @Override
+ public void addTestRealms(List testRealms) {
+ RealmRepresentation realm = new RealmRepresentation();
+
+ realm.setRealm(REALM_NAME);
+ realm.setEnabled(true);
+
+ realm.setClients(Collections.singletonList(createClient()));
+
+ testRealms.add(realm);
+ }
+
+ private ClientRepresentation createClient() {
+ ClientRepresentation clientRepresentation = new ClientRepresentation();
+
+ clientRepresentation.setId(CLIENT_ID);
+ clientRepresentation.setSecret(SECRET);
+
+ clientRepresentation.setBaseUrl(BASE_URL);
+ clientRepresentation.setRedirectUris(Collections.singletonList(BASE_URL + "/*"));
+ clientRepresentation.setAdminUrl(BASE_URL);
+
+ return clientRepresentation;
+ }
+
+ private void addUser(String login, String email, String password, String... roles) {
+ UserRepresentation userRepresentation = new UserRepresentation();
+
+ userRepresentation.setUsername(login);
+ userRepresentation.setEmail(email);
+ userRepresentation.setEmailVerified(true);
+ userRepresentation.setEnabled(true);
+
+ RealmResource realmResource = adminClient.realm(REALM_NAME);
+ String userId = createUserWithAdminClient(realmResource, userRepresentation);
+
+ resetUserPassword(realmResource.users().get(userId), password, false);
+
+ for (String role : roles)
+ assignRealmRoles(realmResource, userId, role);
+ }
+
+ private String getAuthRoot(SuiteContext suiteContext) {
+ return suiteContext.getAuthServerInfo().getContextRoot().toString();
+ }
+
+ private String encodeUrl(String url) {
+ String result;
+ try {
+ result = URLEncoder.encode(url, "UTF-8");
+ } catch (UnsupportedEncodingException e) {
+ result = url;
+ }
+
+ return result;
+ }
+
+ private void waitForPage(WebDriver driver, final String title) {
+ WebDriverWait wait = new WebDriverWait(driver, 5);
+
+ ExpectedCondition condition = (WebDriver input) -> input.getTitle().toLowerCase().contains(title);
+
+ wait.until(condition);
+ }
+
+ @Before
+ public void createRoles() {
+ RealmResource realm = realmsResouce().realm(REALM_NAME);
+
+ RoleRepresentation correct = new RoleRepresentation(CORRECT_ROLE, CORRECT_ROLE, false);
+ realm.roles().create(correct);
+
+ RoleRepresentation incorrect = new RoleRepresentation(INCORRECT_ROLE, INCORRECT_ROLE, false);
+ realm.roles().create(incorrect);
+ }
+
+ @Before
+ public void addUsers() {
+ addUser(USER_LOGIN, USER_EMAIL, USER_PASSWORD, CORRECT_ROLE);
+ addUser(USER_LOGIN_2, USER_EMAIL_2, USER_PASSWORD_2, INCORRECT_ROLE);
+ }
+
+ @After
+ public void cleanupUsers() {
+ RealmResource providerRealm = adminClient.realm(REALM_NAME);
+ UserRepresentation userRep = ApiUtil.findUserByUsername(providerRealm, USER_LOGIN);
+ if (userRep != null) {
+ providerRealm.users().get(userRep.getId()).remove();
+ }
+
+ RealmResource childRealm = adminClient.realm(REALM_NAME);
+ userRep = ApiUtil.findUserByUsername(childRealm, USER_LOGIN_2);
+ if (userRep != null) {
+ childRealm.users().get(userRep.getId()).remove();
+ }
+ }
+
+ @After
+ public void cleanupRoles() {
+ RealmResource realm = realmsResouce().realm(REALM_NAME);
+
+ RoleResource correctRole = realm.roles().get(CORRECT_ROLE);
+ correctRole.remove();
+
+ RoleResource incorrectRole = realm.roles().get(INCORRECT_ROLE);
+ incorrectRole.remove();
+ }
+
+ @Test
+ public void testCorrectUser() {
+ driver.navigate().to(APPLICATION_URL + "/index.html");
+
+ Assert.assertTrue("Must be on application page", applicationPage.isCurrent());
+
+ applicationPage.goAdmin();
+
+ Assert.assertTrue("Must be on login page", loginPage.isCurrent());
+
+ loginPage.login(USER_LOGIN, USER_PASSWORD);
+
+ Assert.assertTrue("Must be on admin page", adminPage.isCurrent());
+ Assert.assertTrue("Admin page must contain correct div",
+ driver.getPageSource().contains("You are now admin"));
+
+ driver.navigate().to(getAuthRoot(suiteContext)
+ + "/auth/realms/" + REALM_NAME
+ + "/protocol/" + "openid-connect"
+ + "/logout?redirect_uri=" + encodeUrl(BASE_URL));
+
+ Assert.assertTrue("Must be on login page", loginPage.isCurrent());
+
+ }
+
+ @Test
+ public void testIncorrectUser() {
+ driver.navigate().to(APPLICATION_URL + "/index.html");
+
+ Assert.assertTrue("Must be on application page", applicationPage.isCurrent());
+
+ applicationPage.goAdmin();
+
+ Assert.assertTrue("Must be on login page", loginPage.isCurrent());
+
+
+ loginPage.login(USER_LOGIN_2, USER_PASSWORD_2);
+
+ Assert.assertTrue("Must return 403 because of incorrect role",
+ driver.getPageSource().contains("There was an unexpected error (type=Forbidden, status=403)")
+ || driver.getPageSource().contains("\"status\":403,\"error\":\"Forbidden\""));
+ }
+
+ @Test
+ public void testIncorrectCredentials() {
+ driver.navigate().to(APPLICATION_URL + "/index.html");
+
+ Assert.assertTrue("Must be on application page", applicationPage.isCurrent());
+
+ applicationPage.goAdmin();
+
+ Assert.assertTrue("Must be on login page", loginPage.isCurrent());
+
+ loginPage.login(USER_LOGIN, USER_PASSWORD_2);
+
+ Assert.assertEquals("Error message about password",
+ "Invalid username or password.", loginPage.getError());
+ }
+
+}